Sieve Email Filtering: Snooze Extension
Kenneth Murchison
Fastmail US LLC
1429 Walnut Street - Suite 1201
Philadelphia
PA
19102
USA
murch@fastmailteam.com
Ricardo Signes
Fastmail US LLC
1429 Walnut Street - Suite 1201
Philadelphia
PA
19102
USA
rjbs@fastmailteam.com
Neil Jenkins
Fastmail Pty Ltd
Level 2, 114 William Street
Melbourne
VIC
3000
Australia
neilj@fastmailteam.com
ART
EXTRA
Sieve
This document describes the "snooze" extension to the Sieve email filtering language. The "snooze" extension gives Sieve the ability to postpone the delivery of an incoming email message into a target mailbox until a later point in time.

Introduction
Users are not always ready, willing, or able to read and respond to email messages at the time of their arrival. Sometimes it is desirable to have messages appear in a mailbox at a more convenient time for the user to act upon them.
This document defines an extension to the Sieve language that enables scripts to postpone the delivery of a message into a target mailbox until a later point in time.

Conventions Used in This Document
Conventions for notations are as in Section 1.1 of [RFC5228], including use of the "Usage:" label for the definition of action and tagged arguments syntax.
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Capability Identifier
Sieve implementations that support this extension have an identifier of "snooze" for use with the capability mechanism.

Snooze Action

Usage: snooze *AWAKEN-OPTIONS <times: string-list>

The AWAKEN-OPTIONS argument is defined here in ABNF syntax so that it can be modified by other extensions.

AWAKEN-OPTIONS = MAILBOX / WEEKDAYS / TZID
                  ; each option MUST NOT appear more than once
                  ; however, per Section 2.6.2 of RFC 5228,
                  ; the tagged arguments in AWAKEN-OPTIONS
                  ; may appear in any order

MAILBOX  = ":mailbox" string
WEEKDAYS = ":weekdays" string-list
TZID     = ":tzid" string

The "snooze" action cancels the implicit keep and postpones delivery of the message into the specified mailbox at a later point in time.
The snooze action is semantically equivalent to a delayed fileinto action (see Section 4.1 of [RFC5228]). The arguments of the snooze action specify when, where, and how the awakened message will be filed.
A Sieve interpreter MUST implement the snooze action by delivering the message to a special "snoozed" mailbox within its mailstore. IMAP and JMAP servers MUST apply the "Snoozed" attribute to this mailbox. The message will reside in this special mailbox until the prescribed awaken time at which it will be moved into the specified target mailbox.

Mailbox Argument
The optional :mailbox argument is used to specify the target mailbox that the message will be filed into when it is awakened. It is equivalent to the mailbox argument of the fileinto action (see Section 4.1 of [RFC5228]).
If :mailbox is omitted, or if the specified mailbox doesn't exist at the time of awakening, the message will be filed into the user's main mailbox. For instance, in an implementation where an IMAP server is running scripts on behalf of the user at time of delivery, the user's "INBOX" would be the implicit target for awakening messages.

Weekdays Argument
The optional :weekdays argument specifies the set of days on which the specified set of awakening times apply. Each day of the week is expressed as an integer between "0" and "6". "0" is Sunday, "1" is Monday, etc. This syntax matches that of the "weekday" date-part argument to the date test extension (see Section 4.2 of [RFC5260]).
If :weekdays is omitted, the set of awakening times applies to every day of the week.

Times and TZID Arguments
The required times argument, along with the optional :tzid argument, are used to specify when a snoozed message will be awakened. Each time is specified in "hh:mm:ss" format and is interpreted as the local time in the time zone specified by the :tzid argument.
The value of the :tzid argument MUST be a time zone identifier from the IANA Time Zone Database. If :tzid is omitted, the time zone of the Sieve interpreter is used.
The combination of the weekdays and times form a chronological list of awaken times. When a message is snoozed, it is assigned the next future awaken time in the list. If a message is snoozed on a day with no awaken times, or after the last awaken time on a given day, the first awaken time on the next available day is used.
If the local time in the specified time zone occurs more than once (daylight saving to standard time transition), the first occurrence of the specified time value is used. If the local time in the specified time zone does not occur (standard to daylight saving time transition), the specified time value is interpreted using the UTC offset prior to the transition.

Awaken Times Examples
The following examples show, given the specified snooze action and a set of message arrival times, the corresponding times at which the message would be awakened and filed.
The following example shows awaken times rolling into the next day or week. Note that 2020-07-30 falls on a Thursday.

require "snooze";
snooze :weekdays ["1", "3", "5", "2", "4"]
       :tzid "Australia/Melbourne" ["12:00:00",
                                    "08:00:00", "16:00:00"];

Arrival (UTC) | Arrival (Melbourne) | Awaken (Melbourne)
2020-07-30T00:00:00Z | --07-30T10:00:00+10 | --07-30T12:00:00+10
2020-07-30T04:00:00Z | --07-30T14:00:00+10 | --07-30T16:00:00+10
2020-07-30T08:00:00Z | --07-30T18:00:00+10 | --07-31T08:00:00+10
2020-07-31T12:00:00Z | --07-31T22:00:00+10 | --08-03T08:00:00+10
2020-08-01T16:00:00Z | --08-02T02:00:00+10 | --08-03T08:00:00+10
The following example shows awaken times falling before, during, and after a daylight saving to standard time transition. Note that the transition occurs at 2020-11-01T02:00:00-04.

require "snooze";
snooze :tzid "America/New_York" "01:30:00";

Arrival (UTC) | Arrival (New York) | Awaken (New York)
2020-11-01T05:00:00Z | --11-01T01:00:00-04 | --11-01T01:30:00-04
2020-11-01T06:00:00Z | --11-01T01:00:00-05 | --11-02T01:30:00-05
2020-11-01T07:00:00Z | --11-01T02:00:00-05 | --11-02T01:30:00-05
The following example shows awaken times falling before, during, and after a standard to daylight saving time transition. Note that the transition occurs at 2021-03-14T02:00:00-05.

require "snooze";
snooze :tzid "America/New_York" "02:30:00";

Arrival (UTC) | Arrival (New York) | Awaken (New York)
2021-03-13T06:30:00Z | --03-13T01:30:00-05 | --03-13T02:30:00-05
2021-03-14T06:30:00Z | --03-14T01:30:00-05 | --03-14T03:30:00-04
2021-03-14T07:30:00Z | --03-14T03:30:00-04 | --03-15T02:30:00-04

Interaction with Extensions to the Fileinto Action
Some tagged arguments defined in extensions to the fileinto action can be used together with the snooze action. The sections below describe these interactions. Tagged arguments in future extensions to the fileinto action need to describe their interaction with the snooze extension, if any.
When any fileinto extension arguments are used with the snooze extension, the corresponding extension MUST be enabled, and the arguments are defined to have the same syntax, semantics, and treatment as they do with the fileinto action.

Imap4flags Extension
When the "imap4flags" extension is enabled in a script, two additional tagged arguments are added to "snooze" that allow manipulating the set of flags on a snoozed message.

AWAKEN-OPTIONS /= ADDFLAGS / REMOVEFLAGS

ADDFLAGS    = ":addflags" string-list
REMOVEFLAGS = ":removeflags" string-list

The optional :addflags and :removeflags arguments are used to specify which IMAP flags should be added to and/or removed from the set of IMAP flags present on the snoozed message at the time of awakening. Note the set of IMAP flags present at the time of awakening may be the empty set.
If the "setflag" and/or "addflag" actions have been used to store IMAP flags in the imap4flags internal variable, the Sieve interpreter MUST use the current value of the internal variable as the set of flags to associate with the message when storing it into the "snoozed" mailbox.
This document doesn't dictate how the Sieve interpreter will set the IMAP flags. In particular, the Sieve interpreter may work as an IMAP client or may have direct access to the mailstore.
The general requirements for flag handling specified in Section 2 of [RFC5232] MUST be followed.

Example
The following example leverages the Date, Relational, and Imap4flags extensions to snooze messages received after business hours until the following work day. Note that the message is marked as important when it is snoozed, and will be marked as unread when it is awakened.

require ["snooze", "imap4flags", "date", "relational"];

if anyof(header :is "from" "boss@example.com",
         currentdate :is "weekday" "0",
         currentdate :is "weekday" "6",
         currentdate :value "ge" "hour" "17") {
    setflag "\\Important";
    snooze :removeflags "\\Seen"
           :weekdays ["1". "2", "3", "4", "5"]
           :tzid "American/New_York", "09:00";
}

Mailbox Extension
This document extends the definition of the ":create" tagged argument so that it can be used with the snooze action.

AWAKEN-OPTIONS /= CREATE

CREATE = ":create"
           ; MUST NOT be appear unless MAILBOX also appears

If the optional ":create" argument is specified with snooze, it instructs the Sieve interpreter to create the target mailbox, if needed, before attempting to file the awakened message into the target mailbox.

Special-Use Extension
This document extends the definition of the ":specialuse" tagged argument so that it can be used with the snooze action.

AWAKEN-OPTIONS /= SPECIAL-USE

SPECIAL-USE = ":specialuse" string

If the optional ":specialuse" argument is specified with snooze, it instructs the Sieve interpreter to check whether a mailbox exists with the specific special-use flag assigned to it. If such a mailbox exists, the awakened message is filed into the special-use mailbox. Otherwise, the awakened message is filed into the target mailbox.
If both the optional ":specialuse" and ":create" arguments are specified with snooze, the Sieve interpreter is instructed to create the target mailbox per Section 4.1 of [RFC8579], if needed.

MailboxID Extension
This document extends the definition of the ":mailboxid" tagged argument so that it can be used with the snooze action.

AWAKEN-OPTIONS /= MAILBOXID

MAILBOXID = ":mailboxid" string

If the optional ":mailboxid" argument is specified with snooze, it instructs the Sieve interpreter to check whether a mailbox exists in the user's personal namespace with the specified MAILBOXID. If such a mailbox exists, the awakened message is filed into that mailbox. Otherwise, the awakened message is filed into the target mailbox.
It is an error to specify both ":mailboxid" and ":specialuse" in the same snooze action.

Implementation Status
< RFC Editor: before publication please remove this section and the reference to [RFC7942] >
This section records the status of known implementations of the protocol defined by this specification at the time of posting of this Internet-Draft, and is based on a proposal described in [RFC7942]. The description of implementations in this section is intended to assist the IETF in its decision processes in progressing drafts to RFCs. Please note that the listing of any individual implementation here does not imply endorsement by the IETF. Furthermore, no effort has been spent to verify the information presented here that was supplied by IETF contributors. This is not intended as, and must not be construed to be, a catalog of available implementations or their features. Readers are advised to note that other implementations may exist.
According to [RFC7942], "this will allow reviewers and working groups to assign due consideration to documents that have the benefit of running code, which may serve as evidence of valuable experimentation and feedback that have made the implemented protocols more mature. It is up to the individual working groups to use this information as they see fit".

Cyrus Server
The open source Cyrus Server project is a highly scalable enterprise mail system which supports Sieve email filtering at the point of final delivery. This production level Sieve implementation supports all of the requirements described in this document. This implementation is freely distributable under a BSD style license from Computing Services at Carnegie Mellon University.

Security Considerations
Security considerations are discussed in [RFC5228], [RFC5232], [RFC8579], and [RFC9042].
It is believed that this extension doesn't introduce any additional security concerns.

Privacy Considerations
It is believed that this extension doesn't introduce any privacy considerations beyond those in [RFC5228].

IANA Considerations

Registration of Sieve Extension
This document defines the following new Sieve extension to be added to the registry defined in Section 6.2 of [RFC5228] and located here: https://www.iana.org/assignments/sieve-extensions/sieve-extensions.xhtml#sieve-extensions
IANA are requested to add a capability to the Sieve Extensions registry:
To: iana@iana.org
Subject: Registration of new Sieve extension
Capability name: snooze
Description: Adds the "snooze" action command to postpone delivery of a message into a target mailbox until a later point in time.
RFC number: RFC XXXX
Contact address: The Sieve discussion list <sieve@ietf.org>

Registration of Sieve Action
This document defines the following new Sieve action to be added to the registry defined in Section 3.1 of [I-D.ietf-extra-sieve-action-registry].
IANA are requested to add an action to the Sieve Action registry:
Name: snooze
Description: Postpone delivery of a message into a target mailbox until a later point in time.
References: RFC XXXX, [RFC5232], [RFC5490], [RFC8579], [RFC9042]
Capabilities: "snooze", "imap4flags", "mailbox", "special-use", "mailboxid".
Interactions: Is not compatible with the reject or ereject actions.
Cancels Implicit Keep?: Y
Use with IMAP Events?: Y
Comments: Requires a special "snoozed" mailbox in the mailstore.

Registration of IMAP Mailbox Name Attribute
This document defines the following new IMAP mailbox name attribute to be added to the registry defined in Section 6.2 of [RFC8457] and located here: https://www.iana.org/assignments/imap-mailbox-name-attributes/imap-mailbox-name-attributes.xhtml#imap-mailbox-name-attributes
IANA are requested to add an attribute to the IMAP Mailbox Name Attribute registry:
To: iana@iana.org
Subject: Registration of new IMAP Mailbox Name Attribute
Attribute name: Snoozed
Description: Messages that have been snoozed.
Reference: RFC XXXX

Acknowledgments
The authors would like to thank the following individuals for contributing their ideas and support for writing this specification: Ned Freed, Barry Leiba, and Alexey Melnikov.

Normative References
[tzdb]

Time Zone Database
Internet Assigned Numbers Authority

Informative References
[RFC5228]
[RFC2119]
[RFC8174]
[RFC5260]
[RFC5232]
[RFC8579]
[RFC7942]
[RFC9042]
[I-D.ietf-extra-sieve-action-registry]
[RFC5490]
[RFC8457]

Change History (To be removed by RFC Editor before publication)
Changes since draft-ietf-extra-sieve-snooze-04:
- Miscellaneous editorial changes.
Changes since draft-ietf-extra-sieve-snooze-03:
- Added "snooze" to the Sieve Actions Registry.
Changes since draft-ietf-extra-sieve-snooze-02:
- Updated :mailboxid reference to RFC9042.
- Added an informative reference to RFC8621.
- Miscellaneous editorial changes.
Changes since draft-ietf-extra-sieve-snooze-01:
- Miscellaneous editorial changes.
Changes since draft-ietf-extra-sieve-snooze-00:
- Disallow both :mailboxid and :specialuse in the same snooze action.
- Updated :mailboxid reference to draft-ietf-extra-sieve-mailboxid
- Specified that snooze cancels implicit keep.
- Specified that implementations MUST use a "snoozed" mailbox.
- Added registration of \Snoozed Special-Use Attribute.
- Added example of manipulating IMAP flags at both snooze time and awaken time.
- Miscellaneous editorial changes.